> ## Documentation Index
> Fetch the complete documentation index at: https://docs.coingecko.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Tokens Data by Token Addresses

> This endpoint allows you to **query multiple tokens data based on the provided token contract addresses on a network**

<Tip>
  ### Tips

  * You may add values such as `top_pools` in the `include` param to include top pools along with the pools information.
  * If you would like to query token information such as socials, websites, description, etc., you can go to this endpoint [`/networks/{network}/tokens/{address}/info`](/v3.0.1/reference/token-info-contract-address) instead.
  * Attributes specified in the `include` param will be returned under the top-level "included" key.
  * Set `include_composition=true` to surface the balance and liquidity value of the pool's base and quote tokens. (requires `include=top_pools`)
  * For tokens on a bonding curve (i.e. non-graduated tokens from launchpads), the response will include a `launchpad_details` object containing their graduation status and details.
</Tip>

<Note>
  ### Note

  * Addresses not found in GeckoTerminal will be ignored.
  * This endpoint allows querying **up to 30 contract addresses** per request.
  * The endpoint will only return the top most liquid pool for each token.
  * `total_reserve_in_usd` represents the total reserve of the requested token only across all its pools, not the combined reserve of both tokens in a pair.
  * If the token's market cap is not verified by the team, the API response will return `null` for its market cap value, even though it has a displayed value on GeckoTerminal, which might not be accurate as it often matches the Fully Diluted Valuation (FDV).
  * Market Cap can be verified by and sourced from CoinGecko, and the number may be higher than FDV as it may include Market Cap of tokens issued on other blockchain networks.
  * Cache / Update Frequency:
    * Every 60 seconds for Public API.
    * Every 10 seconds for [Pro API](https://www.coingecko.com/en/api/pricing) (Basic, Analyst, Lite, Pro, Enterprise).
</Note>


## OpenAPI

````yaml api-reference/onchain-demo.json get /networks/{network}/tokens/multi/{addresses}
openapi: 3.0.0
info:
  title: Onchain DEX API (Demo)
  version: 3.0.0
servers:
  - url: https://api.coingecko.com/api/v3/onchain
security:
  - apiKeyAuth: []
  - apiKeyQueryParam: []
paths:
  /networks/{network}/tokens/multi/{addresses}:
    get:
      tags:
        - Tokens
      summary: Tokens Data by Token Addresses
      description: >-
        This endpoint allows you to **query multiple tokens data based on the
        provided token contract addresses on a network**
      operationId: tokens-data-contract-addresses
      parameters:
        - name: network
          in: path
          description: |-
            network ID 
             *refers to [/networks](/v3.0.1/reference/networks-list)
          required: true
          schema:
            type: string
            example: solana
            default: solana
        - name: addresses
          in: path
          description: >-
            token contract address, comma-separated if more than one token
            contract address
          required: true
          schema:
            type: string
            default: >-
              6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN,2g4LS3y2myPe6vj9wTvoBE1wKqxvhnZPoZA9QU9upump
          examples:
            one value:
              value: 6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN
            multiple values:
              value: >-
                6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN,2g4LS3y2myPe6vj9wTvoBE1wKqxvhnZPoZA9QU9upump
        - name: include
          in: query
          required: false
          description: attributes to include
          schema:
            type: string
            enum:
              - top_pools
        - name: include_composition
          in: query
          required: false
          description: 'include pool composition, default: false'
          schema:
            type: boolean
        - name: include_inactive_source
          in: query
          required: false
          description: >-
            include tokens from inactive pools using the most recent swap,
            default: false
          schema:
            type: boolean
            default: false
      responses:
        '200':
          description: Get multiple tokens on a network
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TokensData'
components:
  schemas:
    TokensData:
      type: object
      properties:
        data:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
              type:
                type: string
              attributes:
                type: object
                properties:
                  address:
                    type: string
                  name:
                    type: string
                  symbol:
                    type: string
                  decimals:
                    type: integer
                  image_url:
                    type: string
                  coingecko_coin_id:
                    type: string
                  total_supply:
                    type: string
                  normalized_total_supply:
                    type: string
                  price_usd:
                    type: string
                  fdv_usd:
                    type: string
                  total_reserve_in_usd:
                    type: string
                  volume_usd:
                    type: object
                    properties:
                      h24:
                        type: string
                  market_cap_usd:
                    type: string
                  last_trade_timestamp:
                    type: integer
                  launchpad_details:
                    type: object
                    properties:
                      graduation_percentage:
                        type: number
                      completed:
                        type: boolean
                      completed_at:
                        type: string
                        nullable: true
                      migrated_destination_pool_address:
                        type: string
                        nullable: true
              relationships:
                type: object
                properties:
                  top_pools:
                    type: object
                    properties:
                      data:
                        type: array
                        items:
                          type: object
                          properties:
                            id:
                              type: string
                            type:
                              type: string
        included:
          type: array
          items:
            type: object
            properties:
              id:
                type: string
              type:
                type: string
              attributes:
                type: object
                properties:
                  base_token_price_usd:
                    type: string
                  base_token_price_native_currency:
                    type: string
                  base_token_balance:
                    type: string
                  base_token_liquidity_usd:
                    type: string
                  quote_token_price_usd:
                    type: string
                  quote_token_price_native_currency:
                    type: string
                  quote_token_balance:
                    type: string
                  quote_token_liquidity_usd:
                    type: string
                  base_token_price_quote_token:
                    type: string
                  quote_token_price_base_token:
                    type: string
                  address:
                    type: string
                  name:
                    type: string
                  pool_created_at:
                    type: string
                  fdv_usd:
                    type: string
                  market_cap_usd:
                    type: string
                  price_change_percentage:
                    type: object
                    properties:
                      m5:
                        type: string
                      m15:
                        type: string
                      m30:
                        type: string
                      h1:
                        type: string
                      h6:
                        type: string
                      h24:
                        type: string
                  transactions:
                    type: object
                    properties:
                      m5:
                        type: object
                        properties:
                          buys:
                            type: integer
                          sells:
                            type: integer
                          buyers:
                            type: integer
                          sellers:
                            type: integer
                      m15:
                        type: object
                        properties:
                          buys:
                            type: integer
                          sells:
                            type: integer
                          buyers:
                            type: integer
                          sellers:
                            type: integer
                      m30:
                        type: object
                        properties:
                          buys:
                            type: integer
                          sells:
                            type: integer
                          buyers:
                            type: integer
                          sellers:
                            type: integer
                      h1:
                        type: object
                        properties:
                          buys:
                            type: integer
                          sells:
                            type: integer
                          buyers:
                            type: integer
                          sellers:
                            type: integer
                      h6:
                        type: object
                        properties:
                          buys:
                            type: integer
                          sells:
                            type: integer
                          buyers:
                            type: integer
                          sellers:
                            type: integer
                      h24:
                        type: object
                        properties:
                          buys:
                            type: integer
                          sells:
                            type: integer
                          buyers:
                            type: integer
                          sellers:
                            type: integer
                  volume_usd:
                    type: object
                    properties:
                      m5:
                        type: string
                      m15:
                        type: string
                      m30:
                        type: string
                      h1:
                        type: string
                      h6:
                        type: string
                      h24:
                        type: string
                  reserve_in_usd:
                    type: string
              relationships:
                type: object
                properties:
                  base_token:
                    type: object
                    properties:
                      data:
                        type: object
                        properties:
                          id:
                            type: string
                          type:
                            type: string
                  quote_token:
                    type: object
                    properties:
                      data:
                        type: object
                        properties:
                          id:
                            type: string
                          type:
                            type: string
                  dex:
                    type: object
                    properties:
                      data:
                        type: object
                        properties:
                          id:
                            type: string
                          type:
                            type: string
      example:
        data:
          - id: solana_6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN
            type: token
            attributes:
              address: 6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN
              name: OFFICIAL TRUMP
              symbol: TRUMP
              decimals: 6
              image_url: >-
                https://coin-images.coingecko.com/coins/images/53746/large/trump.png?1737171561
              coingecko_coin_id: official-trump
              total_supply: '999999287864477.0'
              normalized_total_supply: '999999287.864477'
              price_usd: '7.7593694175'
              fdv_usd: '7759363891.78441'
              total_reserve_in_usd: '120404649.1261605909771336'
              volume_usd:
                h24: '40075650.4943209'
              market_cap_usd: '1544052409.96629'
              last_trade_timestamp: 1712534400
            relationships:
              top_pools:
                data:
                  - id: solana_9d9mb8kooFfaD3SctgZtkxQypkshx6ezhbKio89ixyy2
                    type: pool
          - id: solana_2g4LS3y2myPe6vj9wTvoBE1wKqxvhnZPoZA9QU9upump
            type: token
            attributes:
              address: 2g4LS3y2myPe6vj9wTvoBE1wKqxvhnZPoZA9QU9upump
              name: SORACAT
              symbol: SORACAT
              decimals: 6
              image_url: null
              coingecko_coin_id: null
              total_supply: '1000000000000000.0'
              normalized_total_supply: '1000000000.0'
              price_usd: '0.000006746080385'
              fdv_usd: '6746.080385454'
              total_reserve_in_usd: '5234.612487637440901936305'
              volume_usd:
                h24: '921.4153887425'
              market_cap_usd: null
              launchpad_details:
                graduation_percentage: 2.16
                completed: false
                completed_at: null
                migrated_destination_pool_address: null
            relationships:
              top_pools:
                data:
                  - id: solana_7Dyotb31T3wmXzCkVvTERDDz2jvfTCCPmqQJxHHhCXyf
                    type: pool
        included:
          - id: solana_9d9mb8kooFfaD3SctgZtkxQypkshx6ezhbKio89ixyy2
            type: pool
            attributes:
              base_token_price_usd: '7.75936941750700405297072894879571644219473511394842114180224711'
              base_token_price_native_currency: '0.0335814454309559'
              base_token_balance: '15196976.29836'
              base_token_liquidity_usd: '117804627.68340963'
              quote_token_price_usd: '1.00001597169680687218882320993241755255519183313805749907267743'
              quote_token_price_native_currency: '0.00433212677000389'
              quote_token_balance: '201990285.472966'
              quote_token_liquidity_usd: '201993511.60056412'
              base_token_price_quote_token: '7.751722702'
              quote_token_price_base_token: '0.1290035826'
              address: 9d9mb8kooFfaD3SctgZtkxQypkshx6ezhbKio89ixyy2
              name: TRUMP / USDC
              pool_created_at: '2025-01-18T10:39:31Z'
              fdv_usd: '7759363891.7774'
              market_cap_usd: '1551873674.67383'
              price_change_percentage:
                m5: '0.02'
                m15: '0.281'
                m30: '0.287'
                h1: '0.503'
                h6: '0.002'
                h24: '1.815'
              transactions:
                m5:
                  buys: 0
                  sells: 2
                  buyers: 0
                  sellers: 2
                m15:
                  buys: 4
                  sells: 5
                  buyers: 4
                  sellers: 4
                m30:
                  buys: 90
                  sells: 14
                  buyers: 22
                  sellers: 11
                h1:
                  buys: 288
                  sells: 79
                  buyers: 51
                  sellers: 19
                h6:
                  buys: 1335
                  sells: 637
                  buyers: 104
                  sellers: 48
                h24:
                  buys: 3291
                  sells: 2893
                  buyers: 164
                  sellers: 131
              volume_usd:
                m5: '518.3947210745'
                m15: '18970.32159923'
                m30: '499777.689319544'
                h1: '1504499.57602896'
                h6: '7704195.29047455'
                h24: '39298210.3895233'
              reserve_in_usd: '319587246.1986'
            relationships:
              base_token:
                data:
                  id: solana_6p6xgHyF7AeE6TZkSmFsko444wqoP15icUSqi2jfGiPN
                  type: token
              quote_token:
                data:
                  id: solana_EPjFWdd5AufqSSqeM2qN1xzybapC8G4wEGGkZwyTDt1v
                  type: token
              dex:
                data:
                  id: meteora
                  type: dex
          - id: solana_7Dyotb31T3wmXzCkVvTERDDz2jvfTCCPmqQJxHHhCXyf
            type: pool
            attributes:
              base_token_price_usd: >-
                0.00000674608038545403990449730118833308513731848266467627587783560708
              base_token_price_native_currency: '0.0000000294042292075217'
              base_token_balance: '775948727.097393'
              base_token_liquidity_usd: '5234.612487989761'
              quote_token_price_usd: '229.425513515191181971558985213762678077462832438'
              quote_token_price_native_currency: '1.0'
              quote_token_balance: '0.487321883'
              quote_token_liquidity_usd: '111.80407325446483'
              base_token_price_quote_token: '0.00000002940422921'
              quote_token_price_base_token: '34008713.2685048'
              address: 7Dyotb31T3wmXzCkVvTERDDz2jvfTCCPmqQJxHHhCXyf
              name: SORACAT / SOL
              pool_created_at: '2025-10-03T14:42:39Z'
              fdv_usd: '6746.080385'
              market_cap_usd: null
              price_change_percentage:
                m5: '0'
                m15: '2.229'
                m30: '2.229'
                h1: '2.229'
                h6: '2.229'
                h24: '2.229'
              transactions:
                m5:
                  buys: 0
                  sells: 0
                  buyers: 0
                  sellers: 0
                m15:
                  buys: 4
                  sells: 3
                  buyers: 4
                  sellers: 3
                m30:
                  buys: 4
                  sells: 3
                  buyers: 4
                  sellers: 3
                h1:
                  buys: 4
                  sells: 3
                  buyers: 4
                  sellers: 3
                h6:
                  buys: 4
                  sells: 3
                  buyers: 4
                  sellers: 3
                h24:
                  buys: 4
                  sells: 3
                  buyers: 4
                  sellers: 3
              volume_usd:
                m5: '0.0'
                m15: '921.4153887425'
                m30: '921.4153887425'
                h1: '921.4153887425'
                h6: '921.4153887425'
                h24: '921.4153887425'
              reserve_in_usd: '5382.2386'
            relationships:
              base_token:
                data:
                  id: solana_2g4LS3y2myPe6vj9wTvoBE1wKqxvhnZPoZA9QU9upump
                  type: token
              quote_token:
                data:
                  id: solana_So11111111111111111111111111111111111111112
                  type: token
              dex:
                data:
                  id: pump-fun
                  type: dex
  securitySchemes:
    apiKeyAuth:
      type: apiKey
      in: header
      name: x-cg-demo-api-key
    apiKeyQueryParam:
      type: apiKey
      in: query
      name: x_cg_demo_api_key

````